<div class="container mt-3 flex flex-col">
  <div class="flex justify-between items-center">
    <h1 class="font-bold text-lg lg:px-4 lg:text-3xl">ADD Movie</h1>
    <div class="flex">
      <button
        class="
          bg-blue-300
          p-1
          lg:p-2
          rounded
          text-white
          lg:ml-2 lg:mr-2
          hover:bg-blue-800
          mr-2
        "
        (click)="openActor(actormodal)"
      >
        Add Actor
      </button>
      <button
        class="
          bg-blue-300
          p-1
          lg:p-2
          rounded
          text-white
          lg:ml-2 lg:mr-2
          hover:bg-blue-800
        "
        (click)="openProducer(producermodal)"
      >
        Add Producer
      </button>
    </div>
  </div>
  <form
    class="shadow-lg overflow-hidden sm:rounded-md p-3 bg-gray-100 mt-2"
    #movieform="ngForm"
  >
    <div class="form-group">
      <label class="block text-md font-medium text-gray-700">Movie Name</label>
      <input
        ngModel
        #namemovie="ngModel"
        type="text"
        name="movieName"
        placeholder="Enter Movie Name"
        class="
          form-control
          mt-1
          focus:ring-indigo-500 focus:border-indigo-500
          block
          w-full
          shadow-sm
          sm:text-sm
          border-gray-300
          rounded-md
        "
        required
      />
      <div
        *ngIf="namemovie.touched && namemovie.invalid"
        class="alert alert-danger mt-1"
      >
        Movie Name Required
      </div>
    </div>
    <div class="form-group">
      <label class="block text-md font-medium text-gray-700">Movie Year</label>
      <input
        ngModel
        #yearmovie="ngModel"
        name="yearMovie"
        type="text"
        placeholder="Enter Movie Year"
        class="
          mt-1
          focus:ring-indigo-500 focus:border-indigo-500
          block
          w-full
          shadow-sm
          sm:text-sm
          border-gray-300
          rounded-md
        "
        required
      />
      <div
        *ngIf="yearmovie.touched && yearmovie.invalid"
        class="alert alert-danger mt-1"
      >
        Movie Year Required
      </div>
    </div>
    <div class="form-group">
      <label class="block text-md font-medium text-gray-700">Actors</label>
      <ng-multiselect-dropdown
        ng-model="string"
        name="actorMovie"
        #actormovie
        [placeholder]="'Add Actors'"
        [settings]="dropdownSettings"
        [data]="dropDownList"
        class="
          mt-1
          focus:ring-indigo-500 focus:border-indigo-500
          block
          w-full
          shadow-sm
          sm:text-sm
          border-gray-300
          rounded-md
          text-gray-500
        "
      ></ng-multiselect-dropdown>
    </div>
    <div class="form-group">
      <label class="block text-md font-medium text-gray-700">Plot</label>
      <textarea
        ngModel
        #plotmovie="ngModel"
        name="plotMovie"
        class="
          mt-1
          focus:ring-indigo-500 focus:border-indigo-500
          block
          w-full
          shadow-sm
          sm:text-sm
          border-gray-300
          rounded-md
        "
        required
        height="200"
        placeholder="Enter Movie Plot"
      ></textarea>
      <div
        *ngIf="plotmovie.touched && plotmovie.invalid"
        class="alert alert-danger mt-1"
      >
        Movie Plot Required
      </div>
    </div>

    <div class="form-group">
      <label class="block text-md font-medium text-gray-700">Producers</label>
      <select
        ngModel
        #producermovie
        name="producerMovie"
        required
        class="
          mt-1
          focus:ring-indigo-500 focus:border-indigo-500
          block
          w-full
          shadow-sm
          sm:text-sm
          border-gray-300
          rounded-md
        "
        (change)="producerError(producermovie.value)"
      >
        <option value="default">Select Producer</option>
        <option *ngFor="let producer of producers" [id]="producer.producerid">
          {{ producer.name }}
        </option>
      </select>
      <div *ngIf="producerHasError" class="alert alert-danger mt-1">
        Movie Producer Required
      </div>
    </div>
    <div class="form-group">
      <label class="block text-md font-medium text-gray-700"
        >Upload Movie Poster</label
      >
      <input
        #postermovie
        type="file"
        (change)="onFileChange($event)"
        accept="image/png, image/gif, image/jpeg"
        class="
          mt-1
          focus:ring-indigo-500 focus:border-indigo-500
          block
          sm:text-sm
          border-gray-300
        "
      />
    </div>
    <div class="flex justify-center items-center">
      <button
        [disabled]="!movieform.form.valid"
        type="submit"
        class="
          bg-blue-300
          p-2
          rounded-md
          text-white
          lg:ml-2 lg:mr-2 lg:text-3xl
          hover:bg-blue-500
        "
        (click)="
          addMovie(
            namemovie.value,
            yearmovie.value,
            plotmovie.value,
            actormovie.selectedItems,
            producermovie[producermovie.selectedIndex].id
          )
        "
      >
        Add Movie
      </button>
    </div>
  </form>
</div>

<!-- Add Actor Modal -->
<ng-template #actormodal let-modal>
  <div class="modal-header bg-blue-300">
    <h4
      class="modal-title font-bold text-3xl text-white"
      id="modal-basic-title"
    >
      ADD Actor
    </h4>
    <button
      type="button"
      class="close text-white"
      aria-label="Close"
      (click)="modal.dismiss('Cross click')"
    >
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #actorform="ngForm">
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700">Name</label>
        <input
          type="text"
          ngModel
          #actorname="ngModel"
          name="actorName"
          required
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
        />
        <div
          *ngIf="actorname.touched && actorname.invalid"
          class="alert alert-danger mt-1"
        >
          Actor Name Required
        </div>
      </div>
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700">Sex</label>
        <select
          required
          #actorsex
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
          (change)="actorGenderError(actorsex.value)"
        >
          <option value="default">Select Gender</option>
          <option *ngFor="let sex of sexArr">
            {{ sex }}
          </option>
        </select>
        <div *ngIf="actorGenderHasError" class="alert alert-danger mt-1">
          Actor Gender Required
        </div>
      </div>
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700"
          >Date of Birth</label
        >
        <input
          ngModel
          #actordob="ngModel"
          name="actorDob"
          required
          type="date"
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
        />
        <div
          *ngIf="actordob.touched && actordob.invalid"
          class="alert alert-danger mt-1"
        >
          Actor Date of Birth Required
        </div>
      </div>
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700">Bio</label>
        <textarea
          ngModel
          name="actorBio"
          #actorbio="ngModel"
          type="text"
          required
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
        ></textarea>
        <div
          *ngIf="actorbio.touched && actorbio.invalid"
          class="alert alert-danger mt-1"
        >
          Actor Bio Required
        </div>
      </div>
    </form>
  </div>
  <div class="modal-footer">
    <button
      type="button"
      class="bg-yellow-300 p-2 rounded"
      (click)="modal.dismiss('')"
    >
      Cancel
    </button>
    <button
      [disabled]="!actorform.form.valid"
      type="button"
      class="bg-green-400 p-2 rounded"
      (click)="
        modal.close({
          name: actorname.value,
          sex: actorsex.value,
          dob: actordob.value,
          bio: actorbio.value
        })
      "
    >
      Save Actor
    </button>
  </div>
</ng-template>

<!-- Add Producer Modal -->
<ng-template #producermodal let-modal>
  <div class="modal-header bg-blue-300">
    <h4
      class="modal-title font-bold text-3xl text-white"
      id="modal-basic-title"
    >
      ADD Producer
    </h4>
    <button
      type="button"
      class="close text-white"
      aria-label="Close"
      (click)="modal.dismiss('Cross click')"
    >
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #producerform="ngForm">
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700">Name</label>
        <input
          ngModel
          #producername="ngModel"
          name="producerName"
          required
          type="text"
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
        />
        <div
          *ngIf="producername.touched && producername.invalid"
          class="alert alert-danger mt-1"
        >
          Producer Name Required
        </div>
      </div>
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700">Sex</label>
        <select
          required
          #producersex
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
          (change)="producerGenderError(producersex.value)"
        >
          <option value="default">Select Gender</option>
          <option *ngFor="let sex of sexArr">
            {{ sex }}
          </option>
        </select>
        <div *ngIf="producerGenderHasError" class="alert alert-danger mt-1">
          Producer Gender Required
        </div>
      </div>
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700"
          >Date of Birth</label
        >
        <input
          type="date"
          ngModel
          #producerdob="ngModel"
          name="producerDob"
          required
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
        />
        <div
          *ngIf="producerdob.touched && producerdob.invalid"
          class="alert alert-danger mt-1"
        >
          Producer Date of Birth Required
        </div>
      </div>
      <div class="form-group">
        <label class="block text-md font-medium text-gray-700">Bio</label>
        <textarea
          ngModel
          type="text"
          #producerbio="ngModel"
          name="produceBio"
          required
          class="
            form-control
            mt-1
            focus:ring-indigo-500 focus:border-indigo-500
            block
            w-full
            shadow-sm
            sm:text-sm
            border-gray-300
            rounded-md
          "
        ></textarea>
        <div
          *ngIf="producerbio.touched && producerbio.invalid"
          class="alert alert-danger mt-1"
        >
          Producer Bio Required
        </div>
      </div>
    </form>
  </div>
  <div class="modal-footer">
    <button
      type="button"
      class="bg-yellow-300 p-2 rounded"
      (click)="modal.dismiss('cancel button')"
    >
      Cancel
    </button>
    <button
      [disabled]="!producerform.form.valid"
      type="button"
      class="bg-green-400 p-2 rounded"
      (click)="
        modal.close({
          name: producername.value,
          sex: producersex.value,
          dob: producerdob.value,
          bio: producerbio.value
        })
      "
    >
      Save Producer
    </button>
  </div>
</ng-template>
